Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/init/init.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -79,5 +79,5 @@
 /** Report mount operation success */
 static bool mount_report(const char *desc, const char *mntpt,
-    const char *fstype, const char *dev, errno_t rc)
+    const char *fstype, const char *dev, int rc)
 {
 	switch (rc) {
@@ -125,5 +125,5 @@
 		opts = "restore";
 	
-	errno_t rc = vfs_mount_path(ROOT_MOUNT_POINT, fstype, ROOT_DEVICE, opts,
+	int rc = vfs_mount_path(ROOT_MOUNT_POINT, fstype, ROOT_DEVICE, opts,
 	    IPC_FLAG_BLOCKING, 0);
 	if (rc == EOK)
@@ -144,5 +144,5 @@
 static bool mount_locfs(void)
 {
-	errno_t rc = vfs_mount_path(LOCFS_MOUNT_POINT, LOCFS_FS_TYPE, "", "",
+	int rc = vfs_mount_path(LOCFS_MOUNT_POINT, LOCFS_FS_TYPE, "", "",
 	    IPC_FLAG_BLOCKING, 0);
 	return mount_report("Location service filesystem", LOCFS_MOUNT_POINT,
@@ -150,7 +150,7 @@
 }
 
-static errno_t srv_startl(const char *path, ...)
-{
-	vfs_stat_t s;
+static int srv_startl(const char *path, ...)
+{
+	struct stat s;
 	if (vfs_stat_path(path, &s) != EOK) {
 		printf("%s: Unable to stat %s\n", NAME, path);
@@ -174,5 +174,5 @@
 	task_id_t id;
 	task_wait_t wait;
-	errno_t rc = task_spawn(&id, &wait, path, cnt, ap);
+	int rc = task_spawn(&id, &wait, path, cnt, ap);
 	va_end(ap);
 	
@@ -208,12 +208,12 @@
 		    path, retval);
 	
-	return retval == 0 ? EOK : EPARTY;
-}
-
-static errno_t console(const char *isvc, const char *osvc)
+	return retval;
+}
+
+static int console(const char *isvc, const char *osvc)
 {
 	/* Wait for the input service to be ready */
 	service_id_t service_id;
-	errno_t rc = loc_service_get_id(isvc, &service_id, IPC_FLAG_BLOCKING);
+	int rc = loc_service_get_id(isvc, &service_id, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
 		printf("%s: Error waiting on %s (%s)\n", NAME, isvc,
@@ -233,9 +233,9 @@
 }
 
-static errno_t compositor(const char *isvc, const char *name)
+static int compositor(const char *isvc, const char *name)
 {
 	/* Wait for the input service to be ready */
 	service_id_t service_id;
-	errno_t rc = loc_service_get_id(isvc, &service_id, IPC_FLAG_BLOCKING);
+	int rc = loc_service_get_id(isvc, &service_id, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
 		printf("%s: Error waiting on %s (%s)\n", NAME, isvc,
@@ -256,5 +256,5 @@
 	task_id_t id;
 	task_wait_t wait;
-	errno_t rc = task_spawnl(&id, &wait, app, app, winreg, NULL);
+	int rc = task_spawnl(&id, &wait, app, app, winreg, NULL);
 	if (rc != EOK) {
 		printf("%s: Error spawning %s %s (%s)\n", NAME, app,
@@ -281,5 +281,5 @@
 		    APP_GETTERM, svc, LOCFS_MOUNT_POINT, app);
 		
-		errno_t rc = task_spawnl(NULL, NULL, APP_GETTERM, APP_GETTERM, svc,
+		int rc = task_spawnl(NULL, NULL, APP_GETTERM, APP_GETTERM, svc,
 		    LOCFS_MOUNT_POINT, "--msg", "--wait", "--", app, NULL);
 		if (rc != EOK)
@@ -290,5 +290,5 @@
 		    APP_GETTERM, svc, LOCFS_MOUNT_POINT, app);
 		
-		errno_t rc = task_spawnl(NULL, NULL, APP_GETTERM, APP_GETTERM, svc,
+		int rc = task_spawnl(NULL, NULL, APP_GETTERM, APP_GETTERM, svc,
 		    LOCFS_MOUNT_POINT, "--wait", "--", app, NULL);
 		if (rc != EOK)
@@ -300,5 +300,5 @@
 static bool mount_tmpfs(void)
 {
-	errno_t rc = vfs_mount_path(TMPFS_MOUNT_POINT, TMPFS_FS_TYPE, "", "", 0, 0);
+	int rc = vfs_mount_path(TMPFS_MOUNT_POINT, TMPFS_FS_TYPE, "", "", 0, 0);
 	return mount_report("Temporary filesystem", TMPFS_MOUNT_POINT,
 	    TMPFS_FS_TYPE, NULL, rc);
@@ -307,5 +307,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	info_print();
Index: uspace/app/kill/kill.c
===================================================================
--- uspace/app/kill/kill.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/kill/kill.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 #include <stdio.h>
 #include <task.h>
-#include <str.h>
 #include <str_error.h>
 
@@ -51,5 +50,5 @@
 	char *eptr;
 	task_id_t taskid;
-	errno_t rc;
+	int rc;
 
 	if (argc != 2) {
Index: uspace/app/killall/killall.c
===================================================================
--- uspace/app/killall/killall.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/killall/killall.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,4 @@
 #include <str_error.h>
 #include <stdlib.h>
-#include <str.h>
 
 #define NAME  "killall"
@@ -68,5 +67,5 @@
 		if (str_cmp(stats_tasks[i].name, argv[1]) == 0) {
 			task_id_t taskid = stats_tasks[i].task_id;
-			errno_t rc = task_kill(taskid);
+			int rc = task_kill(taskid);
 			if (rc != EOK)
 				printf("Failed to kill task ID %" PRIu64 ": %s\n",
Index: uspace/app/kio/kio.c
===================================================================
--- uspace/app/kio/kio.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/kio/kio.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -110,5 +110,5 @@
  *
  */
-static errno_t consumer(void *data)
+static int consumer(void *data)
 {
 	FILE *log = fopen(LOG_FNAME, "a");
@@ -187,5 +187,5 @@
 {
 	size_t pages;
-	errno_t rc = sysinfo_get_value("kio.pages", &pages);
+	int rc = sysinfo_get_value("kio.pages", &pages);
 	if (rc != EOK) {
 		fprintf(stderr, "%s: Unable to get number of kio pages\n",
Index: uspace/app/loc/loc.c
===================================================================
--- uspace/app/loc/loc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/loc/loc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 #define NAME "loc"
 
-static errno_t show_cat(const char *cat_name, category_id_t cat_id)
+static int show_cat(const char *cat_name, category_id_t cat_id)
 {
 	service_id_t *svc_ids;
@@ -49,5 +49,5 @@
 	char *svc_name;
 	char *server_name;
-	errno_t rc;
+	int rc;
 	size_t j;
 
@@ -90,5 +90,5 @@
 }
 
-static errno_t list_svcs_by_cat(void)
+static int list_svcs_by_cat(void)
 {
 	category_id_t *cat_ids;
@@ -97,5 +97,5 @@
 	size_t i;
 	char *cat_name;
-	errno_t rc;
+	int rc;
 
 	rc = loc_get_categories(&cat_ids, &cat_cnt);
@@ -136,5 +136,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 	char *cmd;
 	char *cat_name;
Index: uspace/app/logset/main.c
===================================================================
--- uspace/app/logset/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/logset/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,5 @@
 {
 	log_level_t result;
-	errno_t rc = log_level_from_str(log_level, &result);
+	int rc = log_level_from_str(log_level, &result);
 	if (rc != EOK) {
 		fprintf(stderr, "Unrecognised log level '%s': %s.\n",
@@ -62,5 +62,5 @@
 	if (argc == 2) {
 		log_level_t new_default_level = parse_log_level_or_die(argv[1]);
-		errno_t rc = logctl_set_default_level(new_default_level);
+		int rc = logctl_set_default_level(new_default_level);
 
 		if (rc != EOK) {
@@ -72,5 +72,5 @@
 		log_level_t new_level = parse_log_level_or_die(argv[2]);
 		const char *logname = argv[1];
-		errno_t rc = logctl_set_log_level(logname, new_level);
+		int rc = logctl_set_log_level(logname, new_level);
 
 		if (rc != EOK) {
Index: uspace/app/mixerctl/mixerctl.c
===================================================================
--- uspace/app/mixerctl/mixerctl.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/mixerctl/mixerctl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,7 +49,7 @@
 static void print_levels(async_exch_t *exch)
 {
-	char* name = NULL;
+	const char* name = NULL;
 	unsigned count = 0;
-	errno_t ret = audio_mixer_get_info(exch, &name, &count);
+	int ret = audio_mixer_get_info(exch, &name, &count);
 	if (ret != EOK) {
 		printf("Failed to get mixer info: %s.\n", str_error(ret));
@@ -59,7 +59,7 @@
 
 	for (unsigned i = 0; i < count; ++i) {
-		char *name = NULL;
+		const char *name = NULL;
 		unsigned levels = 0, current = 0;
-		errno_t ret =
+		int ret =
 		    audio_mixer_get_item_info(exch, i, &name, &levels);
 		if (ret != EOK) {
@@ -99,5 +99,5 @@
 	const unsigned item = get_number(argv[params++]);
 	const unsigned value = get_number(argv[params]);
-	errno_t ret = audio_mixer_set_item_level(exch, item, value);
+	int ret = audio_mixer_set_item_level(exch, item, value);
 	if (ret != EOK) {
 		printf("Failed to set item level: %s.\n", str_error(ret));
@@ -118,5 +118,5 @@
 	unsigned value = 0;
 
-	errno_t ret = audio_mixer_get_item_level(exch, item, &value);
+	int ret = audio_mixer_get_item_level(exch, item, &value);
 	if (ret != EOK) {
 		printf("Failed to get item level: %s.\n", str_error(ret));
@@ -148,5 +148,5 @@
 
 	service_id_t mixer_sid;
-	errno_t rc = loc_service_get_id(service, &mixer_sid, 0);
+	int rc = loc_service_get_id(service, &mixer_sid, 0);
 	if (rc != EOK) {
 		printf("Failed to resolve service '%s': %s.\n",
Index: uspace/app/mkbd/main.c
===================================================================
--- uspace/app/mkbd/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/mkbd/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -60,5 +60,5 @@
 static async_sess_t *dev_sess = NULL;
 
-static errno_t initialize_report_parser(async_sess_t *dev_sess,
+static int initialize_report_parser(async_sess_t *dev_sess,
     usb_hid_report_t **report)
 {
@@ -67,5 +67,5 @@
 		return ENOMEM;
 	
-	errno_t rc = usb_hid_report_init(*report);
+	int rc = usb_hid_report_init(*report);
 	if (rc != EOK) {
 		usb_hid_report_deinit(*report);
@@ -131,5 +131,5 @@
 	
 	uint8_t report_id;
-	errno_t rc = usb_hid_parse_report(report, buffer, size, &report_id);
+	int rc = usb_hid_parse_report(report, buffer, size, &report_id);
 	if (rc != EOK)
 		return;
@@ -165,5 +165,5 @@
 }
 
-static errno_t wait_for_quit_fibril(void *arg)
+static int wait_for_quit_fibril(void *arg)
 {
 	console_ctrl_t *con = console_init(stdin, stdout);
@@ -218,5 +218,5 @@
 	devman_handle_t dev_handle = 0;
 	
-	errno_t rc = usb_resolve_device_handle(devpath, &dev_handle);
+	int rc = usb_resolve_device_handle(devpath, &dev_handle);
 	if (rc != EOK) {
 		printf("Device not found or not of USB kind: %s.\n",
@@ -237,6 +237,4 @@
 	rc = devman_fun_get_path(dev_handle, path, MAX_PATH_LENGTH);
 	if (rc != EOK) {
-		printf(NAME ": failed to get path (handle %"
-		       PRIun "): %s.\n", dev_handle, str_error(errno));
 		return ENOMEM;
 	}
@@ -264,5 +262,4 @@
 	uint8_t *event = (uint8_t *)malloc(size);
 	if (event == NULL) {
-		printf("Out of memory.\n");
 		// TODO: hangup phone?
 		return ENOMEM;
Index: uspace/app/mkexfat/mkexfat.c
===================================================================
--- uspace/app/mkexfat/mkexfat.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/mkexfat/mkexfat.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -112,9 +112,9 @@
 vbr_checksum_update(void const *octets, size_t nbytes, uint32_t *checksum);
 
-static errno_t
+static int
 ebs_write(service_id_t service_id, exfat_cfg_t *cfg,
     int base, uint32_t *chksum);
 
-static errno_t
+static int
 bitmap_write(service_id_t service_id, exfat_cfg_t *cfg);
 
@@ -284,5 +284,5 @@
 }
 
-static errno_t
+static int
 bootsec_write(service_id_t service_id, exfat_cfg_t *cfg)
 {
@@ -290,5 +290,5 @@
 	uint32_t vbr_checksum;
 	uint32_t *chksum_sector;
-	errno_t rc;
+	int rc;
 	unsigned idx;
 
@@ -344,13 +344,12 @@
  * @param cfg  Pointer to the exFAT configuration structure.
  * @param base Base sector of the EBS.
- * @return  EOK on success or an error code.
- */
-static errno_t
+ * @return  EOK on success or a negative error code.
+ */
+static int
 ebs_write(service_id_t service_id, exfat_cfg_t *cfg, int base,
     uint32_t *chksum)
 {
 	uint32_t *ebs = calloc(cfg->sector_size, sizeof(uint8_t));
-	int i;
-	errno_t rc;
+	int i, rc;
 
 	if (!ebs)
@@ -397,12 +396,12 @@
  * @param service_id  The service id.
  * @param cfg Pointer to the exfat_cfg structure.
- * @return EOK on success or an error code.
- */
-static errno_t
+ * @return EOK on success or a negative error code.
+ */
+static int
 fat_initialize(service_id_t service_id, exfat_cfg_t *cfg)
 {
 	unsigned long i;
 	uint32_t *pfat;
-	errno_t rc;
+	int rc;
 
 	pfat = calloc(cfg->sector_size, 1);
@@ -437,11 +436,11 @@
  * @param cur_cls  Cluster index from where to start the allocation.
  * @param ncls  Number of clusters to allocate.
- * @return EOK on success or an error code.
- */
-static errno_t
+ * @return EOK on success or a negative error code.
+ */
+static int
 fat_allocate_clusters(service_id_t service_id, exfat_cfg_t *cfg,
     uint32_t cur_cls, unsigned long ncls)
 {
-	errno_t rc;
+	int rc;
 	unsigned const fat_entries = cfg->sector_size / sizeof(uint32_t);
 	aoff64_t fat_sec = cur_cls / fat_entries + FAT_SECTOR_START;
@@ -494,12 +493,12 @@
  * @param service_id   The service id.
  * @param cfg  Pointer to the exfat configuration structure.
- * @return  EOK on success or an error code.
- */
-static errno_t
+ * @return  EOK on success or a negative error code.
+ */
+static int
 bitmap_write(service_id_t service_id, exfat_cfg_t *cfg)
 {
 	unsigned long i, sec;
 	unsigned long allocated_cls;
-	errno_t rc = EOK;
+	int rc = EOK;
 	bool need_reset = true;
 
@@ -544,8 +543,8 @@
 
 /** Write the upcase table to disk. */
-static errno_t
+static int
 upcase_table_write(service_id_t service_id, exfat_cfg_t *cfg)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 	aoff64_t start_sec, nsecs, i;
 	uint8_t *table_ptr;
@@ -593,7 +592,7 @@
  * @param service_id   The service id.
  * @param cfg   Pointer to the exFAT configuration structure.
- * @return   EOK on success or an error code.
- */
-static errno_t
+ * @return   EOK on success or a negative error code.
+ */
+static int
 root_dentries_write(service_id_t service_id, exfat_cfg_t *cfg)
 {
@@ -601,5 +600,5 @@
 	aoff64_t rootdir_sec;
 	uint16_t wlabel[EXFAT_VOLLABEL_LEN + 1];
-	errno_t rc;
+	int rc;
 	uint8_t *data;
 	unsigned long i;
@@ -758,6 +757,5 @@
 	char *dev_path;
 	service_id_t service_id;
-	errno_t rc;
-	int c, opt_ind;
+	int rc, c, opt_ind;
 	aoff64_t user_fs_size = 0;
 
Index: uspace/app/mkfat/mkfat.c
===================================================================
--- uspace/app/mkfat/mkfat.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/mkfat/mkfat.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,5 +48,4 @@
 #include <inttypes.h>
 #include <errno.h>
-#include <str.h>
 #include "fat.h"
 #include "fat_dentry.h"
@@ -87,6 +86,6 @@
 static void syntax_print(void);
 
-static errno_t fat_params_compute(struct fat_cfg *cfg);
-static errno_t fat_blocks_write(struct fat_cfg const *cfg, service_id_t service_id);
+static int fat_params_compute(struct fat_cfg *cfg);
+static int fat_blocks_write(struct fat_cfg const *cfg, service_id_t service_id);
 static void fat_bootsec_create(struct fat_cfg const *cfg, struct fat_bs *bs);
 
@@ -95,5 +94,5 @@
 	struct fat_cfg cfg;
 
-	errno_t rc;
+	int rc;
 	char *dev_path;
 	service_id_t service_id;
@@ -253,5 +252,5 @@
 }
 
-static errno_t fat_label_encode(void *dest, const char *src)
+static int fat_label_encode(void *dest, const char *src)
 {
 	int i;
@@ -285,5 +284,5 @@
  * file system params.
  */
-static errno_t fat_params_compute(struct fat_cfg *cfg)
+static int fat_params_compute(struct fat_cfg *cfg)
 {
 	uint32_t fat_bytes;
@@ -357,5 +356,5 @@
 
 /** Create file system with the given parameters. */
-static errno_t fat_blocks_write(struct fat_cfg const *cfg, service_id_t service_id)
+static int fat_blocks_write(struct fat_cfg const *cfg, service_id_t service_id)
 {
 	aoff64_t addr;
@@ -363,5 +362,5 @@
 	int i;
 	uint32_t j;
-	errno_t rc;
+	int rc;
 	struct fat_bs bs;
 	fat_dentry_t *de;
Index: uspace/app/mkmfs/mkmfs.c
===================================================================
--- uspace/app/mkmfs/mkmfs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/mkmfs/mkmfs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -82,15 +82,15 @@
 static void	help_cmd_mkmfs(help_level_t level);
 static bool	is_power_of_two(uint32_t n);
-static errno_t	init_superblock(struct mfs_sb_info *sb);
-static errno_t	write_superblock(const struct mfs_sb_info *sbi);
-static errno_t	write_superblock3(const struct mfs_sb_info *sbi);
-static errno_t	init_bitmaps(const struct mfs_sb_info *sb);
-static errno_t	init_inode_table(const struct mfs_sb_info *sb);
-static errno_t	make_root_ino(const struct mfs_sb_info *sb);
-static errno_t	make_root_ino2(const struct mfs_sb_info *sb);
+static int	init_superblock(struct mfs_sb_info *sb);
+static int	write_superblock(const struct mfs_sb_info *sbi);
+static int	write_superblock3(const struct mfs_sb_info *sbi);
+static int	init_bitmaps(const struct mfs_sb_info *sb);
+static int	init_inode_table(const struct mfs_sb_info *sb);
+static int	make_root_ino(const struct mfs_sb_info *sb);
+static int	make_root_ino2(const struct mfs_sb_info *sb);
 static void	mark_bmap(uint32_t *bmap, int idx, int v);
-static errno_t	insert_dentries(const struct mfs_sb_info *sb);
-
-static inline errno_t write_block(aoff64_t off, size_t size, const void *data);
+static int	insert_dentries(const struct mfs_sb_info *sb);
+
+static inline int write_block(aoff64_t off, size_t size, const void *data);
 
 static service_id_t service_id;
@@ -109,6 +109,5 @@
 int main (int argc, char **argv)
 {
-	errno_t rc;
-	int c, opt_ind;
+	int rc, c, opt_ind;
 	char *device_name;
 	size_t devblock_size;
@@ -290,11 +289,11 @@
  * @param sb		Pointer to the superblock structure.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t insert_dentries(const struct mfs_sb_info *sb)
+ * @return		EOK on success or a negative error code.
+ */
+static int insert_dentries(const struct mfs_sb_info *sb)
 {
 	void *root_block;
 	uint8_t *dentry_ptr;
-	errno_t rc;
+	int rc;
 	const long root_dblock = sb->first_data_zone;
 
@@ -343,11 +342,11 @@
  * @param sb		Pointer to the superblock structure.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t init_inode_table(const struct mfs_sb_info *sb)
+ * @return		EOK on success or a negative error code.
+ */
+static int init_inode_table(const struct mfs_sb_info *sb)
 {
 	unsigned int i;
 	uint8_t *itable_buf;
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	long itable_off = sb->zbmap_blocks + sb->ibmap_blocks + 2;
@@ -376,10 +375,10 @@
  * @param sb		Ponter to the superblock structure.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t make_root_ino(const struct mfs_sb_info *sb)
+ * @return		EOK on success or a negative error code.
+ */
+static int make_root_ino(const struct mfs_sb_info *sb)
 {
 	struct mfs_inode *ino_buf;
-	errno_t rc;
+	int rc;
 
 	const long itable_off = sb->zbmap_blocks + sb->ibmap_blocks + 2;
@@ -413,10 +412,10 @@
  * @param sb		Pointer to the superblock structure.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t make_root_ino2(const struct mfs_sb_info *sb)
+ * @return		EOK on success or a negative error code.
+ */
+static int make_root_ino2(const struct mfs_sb_info *sb)
 {
 	struct mfs2_inode *ino_buf;
-	errno_t rc;
+	int rc;
 
 	/* Compute offset of the first inode table block */
@@ -452,7 +451,7 @@
  * @param sb		Pointer to the superblock structure.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t init_superblock(struct mfs_sb_info *sb)
+ * @return		EOK on success or a negative error code.
+ */
+static int init_superblock(struct mfs_sb_info *sb)
 {
 	aoff64_t inodes;
@@ -460,5 +459,5 @@
 	unsigned long ind2;
 	unsigned long zones;
-	errno_t rc;
+	int rc;
 
 	if (sb->longnames)
@@ -559,10 +558,10 @@
  * @param sbi		Pointer to the superblock structure to write on disk.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t write_superblock(const struct mfs_sb_info *sbi)
+ * @return		EOK on success or a negative error code.
+ */
+static int write_superblock(const struct mfs_sb_info *sbi)
 {
 	struct mfs_superblock *sb;
-	errno_t rc;
+	int rc;
 
 	sb = malloc(MFS_SUPERBLOCK_SIZE);;
@@ -592,10 +591,10 @@
  * @param sbi		Pointer to the superblock structure to write on disk.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t write_superblock3(const struct mfs_sb_info *sbi)
+ * @return		EOK on success or a negative error code.
+ */
+static int write_superblock3(const struct mfs_sb_info *sbi)
 {
 	struct mfs3_superblock *sb;
-	errno_t rc;
+	int rc;
 
 	sb = malloc(MFS_SUPERBLOCK_SIZE);
@@ -625,7 +624,7 @@
  * @param sb		Pointer to the superblock structure.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t init_bitmaps(const struct mfs_sb_info *sb)
+ * @return		EOK on success or a negative error code.
+ */
+static int init_bitmaps(const struct mfs_sb_info *sb)
 {
 	uint32_t *ibmap_buf, *zbmap_buf;
@@ -634,5 +633,5 @@
 	const unsigned int zbmap_nblocks = sb->zbmap_blocks;
 	unsigned int i;
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	ibmap_buf = malloc(ibmap_nblocks * sb->block_size);
@@ -699,10 +698,10 @@
  * @param data		Pointer to the block content.
  *
- * @return		EOK on success or a error number.
- */
-static inline errno_t write_block(aoff64_t off, size_t size, const void *data)
+ * @return		EOK on success or a negative error number.
+ */
+static inline int write_block(aoff64_t off, size_t size, const void *data)
 {
 	if (shift == 3) {
-		errno_t rc;
+		int rc;
 		aoff64_t tmp_off = off << 1;
 		uint8_t *data_ptr = (uint8_t *) data;
Index: uspace/app/modplay/modplay.c
===================================================================
--- uspace/app/modplay/modplay.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/modplay/modplay.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str_error.h>
 #include <trackmod.h>
 
@@ -79,5 +78,5 @@
 	void *buffer;
 	size_t buffer_size;
-	errno_t rc;
+	int rc;
 
 	if (argc != 2) {
@@ -118,5 +117,5 @@
 	rc = hound_context_connect_target(hound, HOUND_DEFAULT_TARGET);
 	if (rc != EOK) {
-		printf("Error connecting default audio target: %s.\n", str_error(rc));
+		printf("Error connecting default audio target (%d).\n", rc);
 		return 1;
 	}
Index: uspace/app/netecho/comm.c
===================================================================
--- uspace/app/netecho/comm.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/netecho/comm.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,5 +44,4 @@
 #include <stdlib.h>
 #include <stdint.h>
-#include <str.h>
 #include <str_error.h>
 
@@ -72,5 +71,5 @@
 	size_t pos;
 	size_t now;
-	errno_t rc;
+	int rc;
 
 	size = udp_rmsg_size(rmsg);
@@ -110,8 +109,8 @@
 }
 
-errno_t comm_open_listen(const char *port_s)
+int comm_open_listen(const char *port_s)
 {
 	inet_ep2_t epp;
-	errno_t rc;
+	int rc;
 
 	char *endptr;
@@ -143,9 +142,9 @@
 }
 
-errno_t comm_open_talkto(const char *hostport)
+int comm_open_talkto(const char *hostport)
 {
 	inet_ep2_t epp;
 	const char *errmsg;
-	errno_t rc;
+	int rc;
 
 	inet_ep2_init(&epp);
@@ -183,7 +182,7 @@
 }
 
-errno_t comm_send(void *data, size_t size)
+int comm_send(void *data, size_t size)
 {
-	errno_t rc = udp_assoc_send_msg(assoc, &remote, data, size);
+	int rc = udp_assoc_send_msg(assoc, &remote, data, size);
 	if (rc != EOK)
 		return EIO;
Index: uspace/app/netecho/comm.h
===================================================================
--- uspace/app/netecho/comm.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/netecho/comm.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,8 +39,8 @@
 #include <stddef.h>
 
-extern errno_t comm_open_listen(const char *);
-extern errno_t comm_open_talkto(const char *);
+extern int comm_open_listen(const char *);
+extern int comm_open_talkto(const char *);
 extern void comm_close(void);
-extern errno_t comm_send(void *, size_t);
+extern int comm_send(void *, size_t);
 
 #endif
Index: uspace/app/netecho/netecho.c
===================================================================
--- uspace/app/netecho/netecho.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/netecho/netecho.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -75,5 +75,5 @@
 	char cbuf[STR_BOUNDS(1)];
 	size_t offs;
-	errno_t rc;
+	int rc;
 
 	offs = 0;
@@ -137,5 +137,5 @@
 static void netecho_send_messages(char **msgs)
 {
-	errno_t rc;
+	int rc;
 
 	while (*msgs != NULL) {
@@ -154,5 +154,5 @@
 	char *port;
 	char **msgs;
-	errno_t rc;
+	int rc;
 
 	if (argc < 2) {
